#include "global.h"

#define DEFAULT_FREQUENCY 20

bool allModels = false;
int timeout; // timeout in seconds (for each cube)
int maxPathLength = 0;

bool generate_connected = false;

bool equalityVersion;

int frequency = DEFAULT_FREQUENCY;

int frequencyConnectedComponentsSwap = 0;  // based on a special coloring encoding
vector<bool> initialPartition;             // initial partition for minimality check
vector<pair<int, int>> intervallsColoring; // intervalls for partitions based on coloring
int minChromaticNumber;
int minChomaticNumberSubgraph;
int non010colorable;
int hypercoloring;
int hyperedgeColoring;
int non010colorableAll;
int assignmentScoring;           // 0 = count the nubmer of assigned variables ; 1 = estimate the search space cut via recorded frequences
int assignmentCutoff;            // create cube when a certain number of vertex pairs is decided whether the are and edge
int assignmentCutoffPrerun;      // Number of calls of propagator before assignmentCutoff is activated
long assignmentCutoffPrerunTime; // Seconds before calling assignmentCutoff

int cutoff; // cutoff for minimality check

int coloringAlgo; // 0 = simple, 1 = DPLL, 2 = SAT

bool addPermutedColorings;
bool fiveCycleVersion;

int thickness2Frequency; // frequency for checking whether the graph has indeed thickness 2

string cubeFile;           // name of file containing cubes
pair<int, int> rangeCubes; // solve all cubes between rangeCubes.fist and rangeCubes.second;

const char **optionsClingo;
int nOptionsClingo;

bool useCadical = false;

bool printFullMatrix;

int printPartiallyDefined;

// -------------------
statistics stats;
bool printStats;
bool printIntermediateStatistic;

pair<int, int> embeddedStar;                              // min and max Degree
vector<pair<int, pair<int, int>>> embeddedStarIntervalls; // contain the neighbors of the root of the star, and the intervall of 2nd neighbors

bool checkComplement;
bool turnoffPropagatorClingo;
bool turnoffSMS;
bool turnOffInprocessing;
bool printFullyDefinedGraphs;

bool triangleVersion;

string proofFile;

vector<vector<vertex_t>> initialVertexOrderings;

vector<vector<pair<int, int>>> forbiddenSubgraphs; // a list of edge-lists, which give forbidden subgraphs
bool eliminateAllsubgraphs;
int planarityFrequency;

bool chechSolutionInProp;      // check solution in the propagator and continous search without restart
bool hideGraphs;               // don't print models
bool propagateLiteralsCadical; // whether only literals should be propagated and clauses added at conflict analysis


bool irredundantSymClauses; // don't let the symmetry breaking clauses be part of the clause deletion policy
