#include "filter.hpp"

// only works up to 32 vertices
bool is_connected(const adjacency_matrix_t &matrix, int n) {
  uint32_t reachable = 1; // the set containing only the vertex 0
  uint32_t open = 1;
  uint32_t visited = 0;
  uint32_t all_verts = (1 << n) - 1;
  //std::cout << "ENT" << std::endl;
  //std::cout << std::flush;
  while (open) {
    int w = ls1b(open);
    //std::cout << w << std::endl;
    uint32_t neighbors = 0;
    for (int v = 0; v < n; v++) {
      if (matrix[w][v] == 1) {
        neighbors |= 1 << v;
      }
    }
    reachable |= neighbors;
    visited |= 1 << w;
    open = all_verts & (open | neighbors) & ~visited;
    if (reachable == all_verts) {
      //std::cout << "CON" << std::endl;
      return true;
    }
  }
  //std::cout << "DIS" << std::endl;
  return false;
}
