#include "useful.h"

class LimitReachedException
{
};

typedef std::vector<vertex_t> vertex_ordering_t;
typedef std::vector<bool> partition_t; // if true, then new partition starts

typedef struct
{
    partition_t initial_partition; // true if new partition starts
    int cutoff;
} minimalit_check_config_t; // used for different configurations of the minimality check

/**
 * Check if graph is minimal and add a clause if this is not the case.
 * Throws std::vector<signed_edge_t> if current partially defined graph is not minimal
 * Throws LimitReachedException if cutoff limit is reached
 */
void checkMinimality(adjacency_matrix_t &adjacency_matrix, vertex_ordering_t vertex_ordering, minimalit_check_config_t config);
void checkMinimalityComplement(adjacency_matrix_t &adjacency_matrix, vertex_ordering_t vertex_ordering, minimalit_check_config_t config);
