#include "global.h"
#include "path.h"

void path_rec(adjacency_matrix_t m, vector<int> path, int depth)
{
    if (depth == maxPathLength + 1)
    {
        throw path;
    }

    if (depth == 0)
    {
        for (int v = 0; v < vertices; v++)
            path_rec(m, {v}, 1);
        return;
    }

    for (int v = 0; v < vertices; v++)
    {
        if (v == path[depth - 1] || m[v][path[depth - 1]] != adjacent)
            continue;
        bool alreadyPresent = false;
        for (size_t i = 0; i < path.size(); i++)
            if (v == path[i])
            {
                alreadyPresent = true;
                break;
            }

        if (alreadyPresent)
            continue;

        vector<int> pathCopy = path;
        pathCopy.push_back(v);
        path_rec(m, pathCopy, depth + 1);
    }
}

// throws a path if found
void path(adjacency_matrix_t m)
{
    vector<int> p;
    path_rec(m, p, 0);
}