#include "useful.h"
#include "global.h"

void printAdjacencyMatrix(const adjacency_matrix_t &matrix)
{
  if (printFullMatrix)
    for (auto row : matrix)
    {
      for (auto value : row)
        printf("%d ", value);
      printf("\n");
    }

  printf("[");
  bool first = true;

#ifndef DIRECTED
  for (int i = 0; i < (int)matrix.size(); i++)
    for (int j = i + 1; j < (int)matrix.size(); j++)
      if (matrix[i][j] == adjacent)
      {
        if (first)
          printf("(%d,%d)", i, j);
        else
          printf(",(%d,%d)", i, j);
        first = false;
      }
  printf("]\n");
#else
  for (int i = 0; i < (int)matrix.size(); i++)
    for (int j = 0; j < (int)matrix.size(); j++)
      if (matrix[i][j] == adjacent)
      {
        if (first)
          printf("(%d,%d)", i, j);
        else
          printf(",(%d,%d)", i, j);
        first = false;
      }
  printf("]\n");
#endif
}

void printPartiallyDefinedAdjacencyMatrix(const adjacency_matrix_t &matrix)
{

#ifndef DIRECTED
  printf("["); // other one
  printf("[");
  bool first = true;
  for (int i = 0; i < (int)matrix.size(); i++)
    for (int j = i + 1; j < (int)matrix.size(); j++)
      if (matrix[i][j] == adjacent)
      {
        if (first)
          printf("(%d,%d)", i, j);
        else
          printf(",(%d,%d)", i, j);
        first = false;
      }
  printf("],");

  printf("[");
  first = true;
  for (int i = 0; i < (int)matrix.size(); i++)
    for (int j = i + 1; j < (int)matrix.size(); j++)
      if (matrix[i][j] == not_adjacent)
      {
        if (first)
          printf("(%d,%d)", i, j);
        else
          printf(",(%d,%d)", i, j);
        first = false;
      }
  printf("],");

  printf("[");
  first = true;
  for (int i = 0; i < (int)matrix.size(); i++)
    for (int j = i + 1; j < (int)matrix.size(); j++)
      if (matrix[i][j] == unknown)
      {
        if (first)
          printf("(%d,%d)", i, j);
        else
          printf(",(%d,%d)", i, j);
        first = false;
      }
  printf("]");
  printf("]\n"); // other one
#else
  printf("[");
  bool first = true;
  for (int i = 0; i < (int)matrix.size(); i++)
    for (int j = 0; j < (int)matrix.size(); j++)
      if (matrix[i][j] == adjacent)
      {
        if (first)
          printf("(%d,%d)", i, j);
        else
          printf(",(%d,%d)", i, j);
        first = false;
      }
  printf("]\n");
#endif
}

void printHypergraph(const adjacency_matrix_t &matrix, int nVertices[2])
{
  char aux[3] = {',', '[', '{'};
  int och = 1;
  for (int e = nVertices[0]; e < nVertices[0] + nVertices[1]; e++)
  {
    printf("%c", aux[och]);
    och = 0;
    int ich = 2;
    for (int v = 0; v < nVertices[0]; v++)
    {
      if (matrix[v][e] == adjacent)
      {
        printf("%c%d", aux[ich], v);
        ich = 0;
      }
    }
    printf("}");
  }
  printf("]\n");
}
